%define shortname	z
%define major 1
%define libname		%mklibname %{shortname}%{major}
%define biarchname	lib%{shortname}%{major}
%define develname	%mklibname %{shortname} -d
%define libminizip %mklibname minizip %{major}
%define minizip_devel %mklibname minizip -d

%define build_biarch 0
# Enable bi-arch build on x86-64
%ifarch x86_64
%define build_biarch 1
%endif
%define build_minizip 1

%bcond_with	uclibc
%bcond_with	dietlibc

Summary:	The zlib compression and decompression library
Name:		zlib
Version:	1.2.8
Release:	2
Group:		System/Libraries
License:	BSD
URL:		http://www.gzip.org/zlib/
Source0:	http://www.zlib.net/%{name}-%{version}.tar.gz
BuildRequires:	setarch
%if %{with uclibc}
BuildRequires:	uClibc-devel >= 0.9.32-2
%endif
%if %{with dietlibc}
BuildRequires:	dietlibc-devel
%endif

%description
The zlib compression library provides in-memory compression and
decompression functions, including integrity checks of the uncompressed
data.  This version of the library supports only one compression method
(deflation), but other algorithms may be added later, which will have
the same stream interface.  The zlib library is used by many different
system programs.

%package -n	%{libname}
Summary:	The zlib compression and decompression library
Group:		System/Libraries
%rename		%{_lib}zlib1
%rename		%{name}
%rename		%{name}1

%description -n	%{libname}
The zlib compression library provides in-memory compression and
decompression functions, including integrity checks of the uncompressed
data.  This version of the library supports only one compression method
(deflation), but other algorithms may be added later, which will have
the same stream interface.  The zlib library is used by many different
system programs.

%if %{build_biarch}
%package -n	%{biarchname}
Summary:	The zlib compression and decompression library - biarch
Group:		System/Libraries
Conflicts:	zlib1 < 1.2.6-3

%description -n %{biarchname}
This package contains the zlib biarch library.
%endif

%if %{with uclibc}
%package -n	uclibc-%{libname}
Summary:	The zlib compression and decompression library linked against uClibc
Group:		System/Libraries
Conflicts:	zlib1 < 1.2.6-4

%description -n	uclibc-%{libname}
This package contains a version of the zlib library that's built against the
uClibc library.
%endif

%package -n	%{develname}
Summary:	Header files and libraries for developing apps which will use zlib
Group:		Development/C
Requires:	%{libname} = %{version}-%{release}
%rename		%{_lib}zlib-devel
%rename		%{name}-devel
%rename		%{name}1-devel

%description -n	%{develname}
The zlib-devel package contains the header files and libraries needed
to develop programs that use the zlib compression and decompression
library.

Install the zlib-devel package if you want to develop applications that
will use the zlib library.

%if %build_minizip
%package -n     %{libminizip}
Summary:        Minizip manipulates files from a .zip archive
Group:          System/Libraries

%description -n %{libminizip}
Minizip manipulates files from a .zip archive.

%package -n     %{minizip_devel}
Summary:        Development files for the minizip library
Group:          Development/C
Requires:       %{libminizip} = %{version}-%{release}
Requires:       zlib-devel = %{version}-%{release}
Provides:       libminizip-devel = %{version}-%{release}
Provides:       minizip-devel = %{version}-%{release}

%description -n %{minizip_devel}
This package contains the libraries and header files needed for
developing applications which use minizip.
%endif

%prep
%setup -q

#(peroyvind): be sure to remove -m64/-m32 flags as they're not overridable
RPM_OPT_FLAGS="`echo $RPM_OPT_FLAGS| sed -e 's/-m.. //g'` -O3"
mkdir objs
cp -a $(ls | grep -v objs) objs/
pushd objs
  CFLAGS="$RPM_OPT_FLAGS" LDFLAGS="%{?ldflags}" \
%if %{build_biarch}
  CC="%{__cc} -m64" \
%endif
  ./configure --shared --prefix=%{_prefix} --libdir=%{_libdir}
  %make
  make test
popd

%if %build_minizip
pushd contrib/minizip
autoreconf --install
%configure --enable-static=no
%make
popd
%endif

%if %{build_biarch}
RPM_OPT_FLAGS_32=`linux32 rpm --eval %%optflags`
mkdir objs32
cp -a $(ls | grep -v objs) objs32/
pushd objs32
  CFLAGS="$RPM_OPT_FLAGS_32" LDFLAGS="%{?ldflags}" CC="%{__cc} -m32" \
  ./configure --shared --prefix=%{_prefix}
  %make
  make test
popd
%endif

%if %build_minizip
pushd contrib/minizip
%makeinstall_std
popd
%endif

%if %{with dietlibc}
mkdir objsdietlibc
pushd objsdietlibc
  CFLAGS="-Os" CC="diet gcc" \
  ../configure --prefix=%{_prefix}
  %make libz.a
popd
%endif

%if %{with uclibc}
mkdir objsuclibc
pushd objsuclibc
  CFLAGS="%{uclibc_cflags}" LDFLAGS="%{?ldflags}" CC="%{uclibc_cc}" \
  ../configure --shared --prefix=%{_prefix}
  %make
popd
%endif

%install
install -d %{buildroot}/%{_prefix}
install -d %{buildroot}/%{_libdir}

make install -C objs prefix=%{buildroot}%{_prefix} libdir=%{buildroot}%{_libdir}
%if %{build_biarch}
make install-libs -C objs32 prefix=%{buildroot}%{_prefix}
%endif

install -d %{buildroot}/%{_lib}
mv %{buildroot}%{_libdir}/*.so.* %{buildroot}/%{_lib}/
ln -s ../../%{_lib}/libz.so.%{version} %{buildroot}%{_libdir}/

%if %build_minizip
pushd contrib/minizip
%makeinstall_std
popd
%endif

%if %{build_biarch}
install -d %{buildroot}/lib
mv %{buildroot}%{_prefix}/lib/*.so.* %{buildroot}/lib/
ln -s ../../lib/libz.so.%{version} %{buildroot}%{_prefix}/lib/
# MD there should be no reason the 32bit devel files should be pkgd
rm -f %{buildroot}%{_prefix}/lib/*.a \
	%{buildroot}%{_prefix}/lib/*.so \
	%{buildroot}%{_prefix}/lib/pkgconfig/zlib.pc
%endif

%if %{with dietlibc}
install -m644 objsdietlibc/libz.a -D %{buildroot}%{_prefix}/lib/dietlibc/lib-%{_arch}/libz.a
%endif

%if %{with uclibc}
install -m644 objsuclibc/libz.a -D %{buildroot}%{uclibc_root}%{_libdir}/libz.a
make install-libs-only -C objsuclibc prefix=%{buildroot}%{uclibc_root} libdir=%{buildroot}%{uclibc_root}%{_libdir}
%endif

%files -n %{libname}
%doc README
/%{_lib}/libz.so.%{major}*
%{_libdir}/libz.so.%{major}*
%if %{with uclibc}
%{uclibc_root}%{_libdir}/libz.so.%{major}*
%endif

%if %{build_biarch}
%files -n %{biarchname}
/lib/libz.so.*
%{_prefix}/lib/libz.so.%{major}*
%endif

%if %{with uclibc}
%files -n uclibc-%{libname}
%{uclibc_root}%{_libdir}/libz.so.%{major}*
%endif

%files -n %{develname}
%doc README ChangeLog doc/algorithm.txt
%{_mandir}/man3/zlib.3*
%{_libdir}/*.a
%{_libdir}/*.so
%{_libdir}/pkgconfig/zlib.pc
%if %{with uclibc}
%{uclibc_root}%{_libdir}/libz.so
%endif
%{_includedir}/*
%if %{with dietlibc}
%{_prefix}/lib/dietlibc/lib-%{_arch}/libz.a
%endif
%if %{with uclibc}
%{uclibc_root}%{_libdir}/libz.a
%endif
%if %build_minizip
%exclude %{_libdir}/libminizip.so
%exclude %{_includedir}/minizip
%endif

%if %build_minizip
%files -n %{libminizip}
%{_libdir}/libminizip.so.%{major}*

%files -n %{minizip_devel}
%{_libdir}/pkgconfig/minizip.pc
%{_libdir}/libminizip.so
%{_includedir}/minizip/*
%endif

%changelog
* Fri Jun 27 2014 Alex Burmashev <alex.burmashev@rosalab.ru> 1.2.8-2
+ Revision: b4bde75
- MassBuild#440: Increase release tag


